## 1 Introduction

Random graph coloring is one of the central and most studied problems in average case complexity, with over three decades of research interleaving the techniques and sensibilities of theoretical computer science, statistical physics, and combinatorics. Many of the most striking phenomena occur in the case of sparse random graphs, and we will focus here on the Erdős-Rényi model , where

fixed and constant and each edge is included independently and with probability

. The full phenomenology of this model is far beyond the scope of this paper to survey (we refer the reader to, for instance, [zdeborova2007phase] for a more complete account), but its key aspect is a series of*phase transitions*in the limit : for fixed , there are critical thresholds in at which certain combinatorial and algorithmic attributes of the coloring problem change abruptly.

The most famous of these is the *colorability transition*, the threshold below which graphs from are with high probability -colorable (that is, with probability as

), and above which they are not. Sophisticated refinements of the first and second moment methods

[achlioptas-naor, coja-oghlan-vilenchik, coja2013upper] have shown thatThese results pin down to within a small additive gap the threshold at which an exponential-time exhaustive search algorithm can find a coloring. What if, on the other hand, we care only about efficient algorithms, say those running in polynomial time?

There are a number of algorithmic tasks that one can consider—distinguishing whether a graph was drawn from or from model with a ‘planted’ -coloring, finding exact or approximate colorings in graphs drawn from the latter, etc.—but all of them seem to become efficiently soluble only when

see [massoulie2014, bordenave-lelarge-massoulie, abbe-sandon-more-groups, mns-colt, non-backtracking] for some examples, many of which are phrased in the related and more general case of *community detection* which we do not treat here. It is conjectured that this point, known as the Kesten-Stigum threshold, is a universal barrier at which polynomial-time algorithms break down.

The purpose of this paper is to add modest evidence to this conjecture, by studying a classic semidefinite programming algorithm for the problem of *refutation*: given a graph , we are to efficiently produce a certificate that is not -colorable or declare failure. As one cannot hope to refute -colorability of when , the Kesten-Stigum threshold conjecture in our case asserts that when , refutation is possible but inaccessible to polynomial time algorithms, whereas it is efficiently soluble when . e programming algorithm for refuting -colorings.

To introduce our refutation algorithm, let us define a *-vector coloring* of an undirected graph as an assignment of a unit vector to each vertex , such that for every edge . This notion was introduced by Karger, Motwani, and Sudan in [karger1998approximate], and equivalent quantities date back to seminal works of Lovàsz and Schrijver [lovasz1979shannon, schrijver1979comparison]. The vector chromatic number of , which we will denote , is the smallest (integer or otherwise) such that a -vector coloring exists. If is -colorable, then it is also -vector-colorable (for instance by associating to each color one of the unit vectors pointing to the corners of a simplex in ), so the vector chromatic number is a relaxation of the chromatic number. More importantly, it is a polynomial-time computable relaxation since it can be formulated as the following semidefinite program:

(1) | |||||

A number of authors have studied the behavior of this and related semidefinite programs on sparse random graphs. In [coja2005lovasz], Coja-Oghlan shows concentration of the Lovàsz function for , and an additional result that translates in our setting to , albeit with non-optimal constants. Montanari and Sen in [montanari16] study an semidefinite programming algorithm for the problem of distinguishing from a planted model guaranteed to have a coloring or community structure, calculating its likely value up to an additive ; the SDP that they consider is similar but incomparable with ours, as they are not concerned with refutation.

Our main theorem characterizes the vector chromatic number of sparse Erdős-Rényi graphs up asymptotically inconsequential terms as the average degree tends to infinity. This strengthens [coja2005lovasz], pinning down the constant exactly and substantially simplifying the method of proof.

###### Theorem 1.

When , with probability ,

In other words, we determine that the threshold in below which the vector chromatic number can prove is not -colorable, and above which it cannot, is . The careful reader will note that, although this matches the scaling of the Kesten-Stigum threshold, the constant factor out front is different: we have shown that refutation with the vector chromatic number becomes impossible when the average degree . This shows that the conjectured “hard regime” indeed stymies our refutation algorithm. Our result complements a result of Banks, Kleinberg, and Moore [banks2019lovasz], who have proved that in random -regular graphs, is similarly concentrated, and fails to refute -coloring as well at four times that model’s KS threshold. Together, these two papers raise a natural question: is this scaling a fundamental barrier for efficient refutation, or can more elaborate methods (perhaps constantly many rounds of the Sum-of-Squares algorithm) succeed all the way down to the Kesten-Stigum threshold itself?

## 2 Roadmap and Results

Banks et al. prove a lower bound on the vector chromatic number with a spectral argument, relying on Friedman’s theorem [friedman2003proof]

to bound the smallest eigenvalue of the adjacency matrix of a random

-regular graph. The upper bound comes from an explicit construction of a feasible solution for the semidefinite program, using orthogonal polynomials. However, neither their upper nor lower bound extend to the model: the spectrum of the adjacency matrix is poorly behaved in Erdős-Rényi random graphs, and the use of orthogonal polynomials requires the graph to be regular.Instead, we will prove Theorem 1 by way of two deterministic results bounding the vector chromatic number of generic graphs. Both bounds are proved by way of non-backtracking walks. To state our results, let be an undirected graph on vertices, and denote by , , and its adjacency, diagonal degree, and non-backtracking matrices. We will introduce in detail below, but for now it is important only that it is a non-normal matrix with zero-one entries. Although its spectrum may be complex-valued, we verify in the sequel that the Perron-Frobenius theorem guarantees one real eigenvalue equal to the spectral radius, which we will denote . This quantity coincides with the growth rate of ’s universal covering tree, and its square root is the spectral radius of the non-backtracking operator on this infinite graph [angel2015non, terras2010zeta].

Our first deterministic result is that the spectrum of can certify non-colorability.

###### Theorem 2.

If is any lower bound on the smallest real eigenvalue of , and is the average degree of , then

To prove this lower bound, we use the celebrated Ihara-Bass identity (forthcoming in Theorem 4) to relate the spectrum of to a family of symmetric matrices,

known variously as the *deformed Laplacian* or Bethe Hessian [saade2014spectral, kotani2000zeta, angel2015non, bass1992ihara, hashimoto1989zeta]. It is observed in [fan2017well, p.13] that spectral assumptions on imply positive-definiteness of for certain on the real line; we use these PSD matrices in a dual argument to lower bound . By a corollary of Bordenave et al. [bordenave-lelarge-massoulie], when we can with probability take , giving the lower bound in Theorem 1.

Second, we derive a girth-dependent lower bound on .

###### Theorem 3.

If ,

The feasible vector coloring we construct in the proof of Theorem 3 assigns a -dimensional unit vector to each vertex , whose coordinates we think of as again being indexed by . In our construction, the coordinate is proportional to the *square root of the probability of going from to in a certain non-backtracking random walk* of length equal to the distance between and . This builds on the key idea in Srivastava and Trevisan’s lower bound results for spectral sparsification [srivastava2018alon], and in the -regular case recovers the result from Banks et al. [banks2019lovasz]. Graphs drawn from have , and this holds even if we condition on the constant probability event that the girth is any large constant of our choosing. Thus we can, with small albeit constant probability, construct -vector colorings with arbitrarily close to . Finally, we adapt a well-known martingale technique developed in [shamir1987sharp, luczak, achlioptas-moore-reg, banks2019lovasz] to guarantee, with high probability, a solution of similar cost.

The above construction can be used to prove two notable corollaries. First, it is also a near-optimal solution to the Goemans-Williamson relaxation of MaxCut in random graphs [goemans1995improved]

. Rounding with random hyperplanes yields a cut of cost

which we believe is the strongest known algorithmically attainable lower bound to the maximum cut in random graphs (a tight bound is known, but the argument is not algorithmic [dembo2017extremal]). In fact, this extends to any high-girth graph:

###### Corollary 1.

If ,

Second, the vectors from Theorem 3 can be used to prove a kind of generalized Alon-Boppana type theorem concerning the deformed Laplacian . The standard Alon-Boppana theorem [nilli1991second] states that -regular graphs with high diameter have have eigenvalues arbitrarily close to ; it has been refined and extended in numerous ways [davidoff2003elementary, §1.3-3][friedman1993some, §3][nilli2004tight], and our result generalizes the fact that regular graphs of large *girth* have eigenvalues approaching . One can verify that these negative eigenvalues translate to eigenvalues of close to for every . For regular graphs is, among other things, the spectral radius of , and we prove a direct generalization in this sense.

###### Corollary 2.

If has girth at least , then for every ,

We will prove Theorems 2 and 3 in §3.2-3.3 after first developing some preliminary results on non-backtracking walks in §3.1. Having done so, we prove Theorem 1 in §3.4 and wrap up in §3.5 with the two corollaries above.

### 2.1 Optimality and Irregular Ramanujan Graphs

The best possible setting of in Theorem 2 is , at which point we obtain the bound

In the case of -regular Ramanujan graphs—those for which the nontrivial eigenvalues of the adjacency matrix have magnitude at most —this matches the standard spectral bound on the chromatic number. For regular graphs, the Ramanujan property is euqivalent to every nontrivial eigenvalue of having magnitude at most ; since in the regular case, some authors to define an irregular graph as Ramanujan if its nontrivial non-backtracking eigenvalues have modulus at most [bordenave-lelarge-massoulie, lubotzky1995cayley]. If a graph is Ramanujan in this sense, we can take , giving

this could only match our upper bound in the case , which is true for regular graphs, approximately true for Erdős-Rényi random graphs, and fails generically.

###### Question 1.

What “Ramanujan” assumption on the spectrum of implies the converse of Theorem 3? Is it enjoyed, either approximately or exactly, by random graphs?

## 3 Proofs

### 3.1 Notation and Non-backtracking Preliminaries

We will write for the unordered set of eigenvalues of a matrix , for the modulus of its largest eigenvalue, and use the standard notation to indicate that a (Hermitian) matrix is positive semidefinite, or in other words that . For two matrices and , will denote the entry-wise product and the Frobenius inner product. It is a standard lemma that implies as well, and that . The set of integers will be denoted by .

To an unweighted, undirected, and connected graph on vertices, we will associate an *adjacency matrix* , *diagonal degree matrix* , and shortest path distance metric . Although is undirected, it will be useful to think of each edge as a pair of directed edges and ; we’ll call the set of these directed edges . For each vertex , write for the set of neighbors of . The central object in our proofs will be the *non-backtracking matrix* associated to ; this is a linear operator on , which we will think of as the vector space of functions . Indexing the standard basis of by the elements of ,

and zero otherwise. True to its name, the powers of encode walks on which are forbidden from returning along the same edge that they have just traversed.

The reader may verify that is a non-normal operator, and therefore its spectrum is in general a complicated subset of the complex plane. Since its entries are nonnegative, however, we can apply the Perron-Frobenius theorem after carefully analyzing the reducibility and periodicity of . The following result, collating [terras2010zeta, Corollary 11.12] and [kotani2000zeta, Proposition 3.1], characterizes these attributes.

###### Proposition 1 (Terras, Kotani, Sudana).

Let be connected. The spectrum of depends only the -core of , and once we restrict to this core, is reducible if and only if is a cycle. Finally, has even period if and only if

is bipartite, and odd period

if and only if is a*subdivision*, e.g. if it is obtained by replacing in a smaller graph every edge with a path of length .

From the perspective of coloring, bipartite graphs and subdivisions are are uninteresting, and vertices outside the -core cannot impact the chromatic number, so let us assume from this point that is non-bipartite and non-subdivided, with minimum degree two.

In this case, the Perron-Frobenius theorem tells us that

, and that the corresponding left and right eigenvectors have positive entries; this positivity will be important, and is the reason we stated Proposition

1 in such detail.An invaluable tool for further analyzing the spectral properties of is a classic result relating its characteristic polynomial to the determinant of a quadratic matrix-valued function involving and and due in various forms to Ihara, Bass, and Hashimoto; see [kotani2000zeta, angel2015non, bass1992ihara, hashimoto1989zeta], to name just a few.

###### Theorem 4 (Ihara, Bass, Hashimoto).

For any graph ,

We will refer to the matrix-valued quadratic

as the *deformed Laplacian*; note that when evaluated at it returns the standard and ‘signless’ Laplacians . The former is always singular, and the latter if and only if is bipartite, so given our assumptions has an eigenvalue at with multiplicity , and one at with multiplicity . The remaining eigenvalues correspond to for which is singular. The key lemma for Theorem 2 relates the spectrum of to the semidefiniteness of for negative ; we first encountered it in [fan2017well, p13].

###### Lemma 1.

For any lower bound on the smallest real eigenvalue of , .

###### Proof.

For , the matrices are symmetric with real spectrum. When , by a simple diagonal dominance argument. It is a standard result that the eigenvalues of a matrix are continuous functions in its entries, so as we increase , the only way can fail to be PSD is for one of its eigenvalues to cross zero. However, by Theorem 4 cannot be singular for any real smaller than the smallest real eigenvalue of . ∎

### 3.2 Theorem 2: The Ihara-Bass Identity and Deformed Laplacian

Let be any positive semidefinite matrix. Writing for the smallest real eigenvalue of , Lemma 1 implies

(2) |

for every . One can check that, subject to the constraint , this function is minimized at the smaller of and . As an aside, we’ve shown:

###### Lemma 2.

If is non-bipartite, and has no real eigenvalues other than and , then for any ,

In the -regular case, Theorem 4 implies that a non-bipartite graph is Ramanujan if and only if has no real eigenvalues besides and , and that this condition implies . Thus Lemma 2 suggests that this condition on the spectrum of may be a natural notion of the Ramanujan property for irregular graphs.

The proof of Theorem 2 will follow from a stronger result:

(3) | ||||

Let satisfy the three conditions above, and assume that is the Gram matrix witnessing , so that has ones on its diagonal and if . We can set in (2), so that

To prove Theorem 2, set .

###### Remark 1.

It is a priori possible that, by carefully tuning , this result could be improved to meet the high-girth limit of the upper bounds in Theorem 3. We have observed numerically, however, that this is not the case.

### 3.3 Theorem 3: A Non-backtracking Random Walk

To prove Theorem 3, we need to produce unit vectors for every , so that the maximum of over all is as negative as possible. Assume that , so that in particular if any vertices are at distance less than , they are connected by a unique non-backtracking (and, indeed, self-avoiding) walk of length . Borrowing an insight of [srivastava2018alon], we will construct these vectors from non-backtracking random walk on the vertices of . By this we mean a random walk which, started at some vertex , chooses on its first step one of the neighbors of , and on subsequent steps makes only non-backtracking moves. Write

for the random variable encoding the position of the walk at time

, and for its distribution upon starting the walk at vertex . We will remain for the moment agnostic as to the actual transition probabilities, so that it is clear which portions of the argument depend on them, and which do not.The will be built as follows: set each to have one coordinate for each , with

We’ve arranged things so that

since after steps the walk has probability one of reaching *some* vertex at distance from its starting point.

It remains to study the inner products between pairs of vectors at neighboring vertices. For any , the inner product depends only on vertices at distance less than from both and . Because of our initial girth assumption, the depth- neighborhoods of and together form a tree in which every vertex satisifies , and we can divide this into a portion of vertices closer to than , and its counterpart closer to than . Let us further segment into layers according to distance from , and similarly for .

Then, directly computing,

The non-backtracking structure of the random walk, and the local tree-like configuration nearby and , allow us to simplify this expression further. When Bayes rule implies

Now, by non-backtracking, the probability of reaching in steps starting from , conditional on reaching on the first step, is the same as the probability of reaching in steps starting at , conditional on the first step not hitting . We can use Bayes again to write

Finally, again by non-backtracking, the information that is redundant once we know that it starts at and reaches in steps, so . Putting together these steps gives us

and thus

We now choose the transition probabilities for our random walk, having simplified the dependence on them of the inner products we are interested in. Recall from the Perron-Frobenius theorem that, under our assumptions on (simple, minimum degree , non-subdivided), is a simple eigenvalue of , and that its corresponding left and right eigenvectors have strictly positive entries. Let’s denote the right eigenvector by , and record explicitly that

(4) |

It will be useful to overload notation and define , observing that 4 implies for every .

We will set the transition probabilities of our random walk proportional to the coordinates of . In other words,

and

Normalization follows immediately from the fact that is a right eigenvector. Returning to the inner product between and ,

from (4) and discussion | ||||

with the final line following (for instance) the inequality of arithmetic and geometric means.

### 3.4 Theorem 1

We are now prepared to study the vector chromatic number of . To prove Theorem 1, we first need to supply a lower bound on —this will follow immediately from Theorem 2, and an established result on the spectrom of in the Erdős-Rényi case [bordenave-lelarge-massoulie, Theorem 3]:

###### Theorem 5.

(Bordenave, Lelarge, and Massoulie) When , with probability , the spectrum of consists of a Perron eigenvalue at , and remaining eigenvalues of magnitude at most .

This result in hand, we know w.h.p. the smallest real eigenvalue of is no smaller than , and so Theorem 2 tells us

w.h.p. as well.

We need to show how to apply Theorem 3 to bound from above. It is a standard lemma that for any constant , with constant probability. On this event, the results of Theorem 6 on the spectrum of still hold with probability , and the average degree of is still , so we can apply Theorem 1 and deduce that, for any and any ,

with probability bounded away from zero.

We now employ a martingale technique and combinatorial argument due to a string of papers establishing concentration for the chromatic number of Erdős-Rényi graphs [shamir1987sharp, luczak, achlioptas-moore-reg], and employed in [banks2019lovasz] for a purpose analogous to ours; the presentation is indebted as well to [balachandran, Theorem 79]. Set and define a random variable as the largest set of vertices inducing a subgraph of with vector chromatic number . By Proposition 1, for any , if we set then with probability at least , for some .

Think of the random graph as being sampled in steps, where on the th one we decide which of the edges will exist between vertex and the prior . If we call the induced subgraph on vertices , then the the random variables induce an increasing sequence of sigma algebras, and the sequence is a martingale. The central claim in every application of this martingale method is that, as at each step we are revealing data about the neighborhood of a single vertex, the conditional expectation of can change by at most one: once the edges between and the previous vertices are revealed, we can simply delete from the graph, and our data about the remaining edges is unchanged.

By Azuma’s inequality, then,

Choosing so that , we immediately have , and thus with probability at least .

Now, let be the set of vertices which we *cannot* -vector color. We will show that this set can be expanded to one which induces a three-colorable subgraph of , and whose boundary with the remaining -vector colorable portion of is an independent set. If there are two vertices which are (1) not connected to one another by an edge and (2) are both connected to vertices in , form a set , and repeat this process to produce sets until there are no such vertices to add. The boundary of is an independent set (or else our expansion process could have continued for another step). Initially, induces a subgraph with at least edges (because if there were an isolated vertex, we could easily extend the vector coloring to it), and at each step, , and . If our process progressed long enough for for some , we’d have and

Since , this means the average degree of the subgraph induced by would be . A union bound shows, though, that small enough subgraphs of size linear in w.h.p. do not have average degree this high, so the process must terminate when . Applying this union bound again, every subgraph of must have average degree smaller than three, so induces a subgraph with no three-core, and can be colored with three colors.

We now need to produce a valid vector coloring on the entire graph, exploiting the preceding decomposition of into a subgraph with , one with , and a independent set separating them. Call the vector coloring on , and (perhaps by increasing the ambient dimension) let be three unit vectors pointing to the corners of a unilateral triangle, and be a vector orthogonal to and . Writing for a valid three-coloring of , our vector coloring will be

One can now directly verify that

### 3.5 Corollaries

###### Proof of Corollary 1.

Our vectors from the proof of Theorem 3 can be used as input to the Goemans-Williamson rounding algorithm [goemans1995improved] for producing large cuts in . Let be the Gram matrix of the , sample , and partition vertices according to the sign of the coordinates of . Calculation of the expected size of such a cut is standard: our vectors have inner product at most , so

In the case, our martingale calculation guarantees with high probability a vector coloring whose inner products satisfy

giving us a cut involving at least

edges. One can compare this to a non-algorithmic result of Dembo, Montanari, and Sen [dembo2017extremal] that the actual maximum cut severs

edges with high probability. ∎

###### Proof of Corollary 2.

To prove Theorem 3, it suffices to produce a matrix with unit trace, and for which is small. Returning to the vectors from the proof of Theorem 1,

so that and for . Let us scale so that .

We will need one additional fact. Writing for the degree of vertex , then from (4) and surrounding discussion,

Using this and our calculations from the proof of Theorem 3,

Writing out and rearranging finishes the proof. Notice also that we’ve shown Lemma 4 is asymptotically tight on high-girth graphs:

∎

## Acknowledgements

We are grateful to Nikhil Srivastava, Archit Kulkarni, Satyaki Mukherjee for illuminating conversations. J.B. is supported by the NSF Graduate Research Fellowship Program under Grant DGE-1752814; L.T is supported by NSF Grant CCF-1815434.

Comments

There are no comments yet.